#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiStatusBar.au3>
#include <GuiToolbar.au3>
#include <StaticConstants.au3>
#include <ToolbarConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>
#include <GuiEdit.au3>
#include <IE.au3>
#include <INet.au3>
#include <GuiRichEdit.au3>



HotKeySet("^{a}", "allesmark")
HotKeySet("^{p}", "print")
HotKeySet("^!{c}", "check")
HotKeySet("{F1}", "hilfe")
HotKeySet("^{s}", "speichern")
HotKeySet("^{z}", "undo")

$ie = _IECreateEmbedded()
$savefile = 0
Dim $eingabetodo[100]
$counteingabetotdo = 0



$form = GUICreate("Cody-der HTML-Editor", 1346, 691, 0, 10)
GUISetBkColor(0x0066CC)
$Logo = GUICtrlCreatePic(@ScriptDir & "\data\logo.jpg", 16, 15, 300, 150)
$Datei = GUICtrlCreateMenu("Datei")
$Oeffnen = GUICtrlCreateMenuItem("ffnen", $Datei)
$Speichern = GUICtrlCreateMenuItem("Speichern", $Datei)
$SpeichernUnter = GUICtrlCreateMenuItem("Speichern Unter", $Datei)
$DruckenCode = GUICtrlCreateMenuItem("Code-Drucken", $Datei)
$DruckenSeite = GUICtrlCreateMenuItem("Seite-Drucken", $Datei)
$Beenden = GUICtrlCreateMenuItem("Beenden", $Datei)
$Bearbeiten = GUICtrlCreateMenu("Bearbeiten")
$Rueckgaengig = GUICtrlCreateMenuItem("Rckgngig", $Bearbeiten)
$Kopieren = GUICtrlCreateMenuItem("Kopieren", $Bearbeiten)
$Einfuegen = GUICtrlCreateMenuItem("Einfgen", $Bearbeiten)
$Ausschneiden = GUICtrlCreateMenuItem("Ausschneiden", $Bearbeiten)
$AllesMarkieren = GUICtrlCreateMenuItem("Alles markieren", $Bearbeiten)
$Tools = GUICtrlCreateMenu("Tools")
$HtmlFarben = GUICtrlCreateMenuItem("Html-Farben", $Tools)
$HtmlHilfe = GUICtrlCreateMenuItem("Html-Hilfe", $Tools)
$Quelltext = GUICtrlCreateMenuItem("Quelltextausleser", $Tools)
$ToDoList = GUICtrlCreateMenu("To-Do Liste")
$ToDoListeAufruf = GUICtrlCreateMenuItem("To-Do Liste aufrufen", $ToDoList)
$ToDoListeEingabe = GUICtrlCreateMenuItem("To-Do Liste/Punkte hinzufgen", $ToDoList)
$ToDoListeLoeschen = GUICtrlCreateMenuItem("To-Do Liste lschen", $ToDoList)
$Hilfe = GUICtrlCreateMenu("Hilfe")
$Hilfe1 = GUICtrlCreateMenuItem("Hilfe...", $Hilfe)
$explorer = GUICtrlCreateObj($ie, 16, 168, 625, 472)
$check = GUICtrlCreateButton("Zeige Code als Seite", 335, 60, 129, 33)
$Exitbutton = GUICtrlCreateButton("Exit", 485, 60, 129, 33)
$statusbar = _GUICtrlStatusBar_Create($form)
$Label1 = GUICtrlCreateLabel("HTML-FENSTER", 380, 130, 336, 36)
GUICtrlSetFont(-1, 20, 400, 0, "MS Sans Serif")
$Label2 = GUICtrlCreateLabel("CODE-FENSTER", 913, 7, 190, 36)
GUICtrlSetFont(-1, 20, 400, 0, "MS Sans Serif")
_GUICtrlStatusBar_SetText($statusbar, "Cody-der HTML-Editor")
$main = GUICtrlCreateEdit("", 680, 40, 625, 600)
GUICtrlSetFont(-1, 10, 200, Default)
GUICtrlSetData(-1, "")
GUISetState(@SW_SHOW)
_IENavigate($ie, @ScriptDir & "\data\tools\start.htm")





While 1
	$msg = GUIGetMsg()
	Switch $msg
		Case $GUI_EVENT_CLOSE
			exitf()

		Case $check
			check()

		Case $Exitbutton
			exitf()

		Case $Oeffnen
			$openfile = FileOpenDialog("Whle die Datei die geffnet werden soll", @ProgramFilesDir, "Websites (*.html; *.htm)")
			$openfileread = FileRead($openfile)
			GUICtrlSetData($main, "")
			GUICtrlSetData($main, $openfileread)


		Case $Speichern
			speichern()



		Case $SpeichernUnter
			$savefile = FileSaveDialog("Bitte whle das Speicherziel aus!", @ProgramFilesDir, "Website (*.html; *htm)")
			FileWrite($savefile & ".html", GUICtrlRead($main))

		Case $DruckenCode
			print()

		Case $DruckenSeite
			printpage()

		Case $Beenden
			exitf()

		Case $Rueckgaengig
			undo()

		Case $Kopieren
			ControlSend("Cody-der HTML-Editor", "", $main, "^{c}")

		Case $Einfuegen
			ControlSend("Cody-der HTML-Editor", "", $main, "^{v}")

		Case $Ausschneiden
			ControlSend("Cody-der HTML-Editor", "", $main, "^{x}")

		Case $AllesMarkieren
			allesmark()

		Case $Hilfe1
			_IENavigate($ie, @ScriptDir & "\data\tools\start.htm")


		Case $Quelltext
			quelltext()

		Case $HtmlFarben
			_IENavigate($ie, @ScriptDir & "\data\tools\farben.html")

		Case $HtmlHilfe
			_IENavigate($ie, @ScriptDir & "\data\tools\hilfen.html")

		Case $ToDoListeAufruf
			todolisteaufruf()

		Case $ToDoListeEingabe
			todolisteeingabe()

		Case $ToDoListeLoeschen
			todolisteloeschen()


	EndSwitch







WEnd


Func hilfe()
	_IENavigate($ie, @ScriptDir & "\data\tools\start.htm")


EndFunc   ;==>hilfe

Func exitf()
	_GUICtrlStatusBar_SetText($statusbar, "Beenden?")
	$exitsavedialog = MsgBox(3, "Exit", "Willst du vor dem Beenden nicht lieber Speichern? Die ToDo-Liste, falls benutzt, wurde automatisch gespeichert!")
	If $exitsavedialog = 2 Then
	ElseIf $exitsavedialog = 7 Then
		Exit
	ElseIf $exitsavedialog = 6 Then
		If Not $savefile = 0 Then
			FileDelete($savefile)
			FileWrite($savefile & ".html", GUICtrlRead($main))
			MsgBox(0, "Erfolgreich", "Erfolgreich gespeichert! Auf Wiedersehen!")
			Exit
		Else
			$savefile = FileSaveDialog("Bitte whle das Speicherziel aus!", @ProgramFilesDir, "Website (*.html; *htm)")
			FileWrite($savefile & ".html", GUICtrlRead($main))
			Exit

		EndIf


	EndIf

	_GUICtrlStatusBar_SetText($statusbar, "Cody-der HTML-Editor")
EndFunc   ;==>exitf



Func print()
	If WinActive("Cody-der HTML-Editor") Then
		_GUICtrlStatusBar_SetText($statusbar, "Code drucken")
		FileDelete(@DocumentsCommonDir & "\htmleditorprint.txt")
		FileWrite(@DocumentsCommonDir & "\htmleditorprint.txt", GUICtrlRead($main))
		Sleep(1000)
		_FilePrint(@DocumentsCommonDir & "\htmleditorprint.txt", @SW_SHOW)
		Sleep(2000)
		MsgBox(0, "Drucken", "Code wird gedruckt!")
	EndIf
	_GUICtrlStatusBar_SetText($statusbar, "Cody-der HTML-Editor")
EndFunc   ;==>print




Func printpage()

	_GUICtrlStatusBar_SetText($statusbar, "Seite drucken")
	FileDelete(@DocumentsCommonDir & "\htmleditorquicksave.html")
	FileWrite(@DocumentsCommonDir & "\htmleditorquicksave.html", GUICtrlRead($main))
	_IENavigate($ie, @DocumentsCommonDir & "\htmleditorquicksave.html")
	_IEAction($ie, "Print")
	Sleep(2000)
	MsgBox(0, "Drucken", "Seite wird gedruckt!")



	_GUICtrlStatusBar_SetText($statusbar,
	"Cody-der HTML-Editor")
EndFunc   ;==>printpage


Func allesmark()
	_GUICtrlEdit_SetSel($main, 0, -1)

EndFunc   ;==>allesmark



Func check()
	FileDelete(@DocumentsCommonDir & "\htmleditorquicksave.html")
	FileWrite(@DocumentsCommonDir & "\htmleditorquicksave.html", GUICtrlRead($main))
	_IENavigate($ie, @DocumentsCommonDir & "\htmleditorquicksave.html")
	ControlClick("", "", $main)

EndFunc   ;==>check


Func quelltext()
	$urlquelltext = InputBox("URl", "Gib die URL-Adresse der Website ein, deren Quelltext du auslesen mchtest! Der Quelltext berschreibt den aktuellen Code im linken Fenster!")
	$urlquelltext = "http://" & StringReplace($urlquelltext, "http://", "")
	ConsoleWrite("QuellText: " & $urlquelltext & @CRLF)
	$quelltextsource = _INetGetSource($urlquelltext)
	GUICtrlSetData($main, $quelltextsource)
EndFunc   ;==>quelltext


Func todolisteeingabe()
	MsgBox(0, "Punkte hinzufgen", "Gib bitte in den folgenden Boxen die Punkte ein, die du der Liste hinzufgen mchtest! Hast du alle Punkte eingegeben, drcke auf Cancel!")
	If Not FileReadLine(@ScriptDir & "\data\tools\todo.html", 1) = "To-Do Liste </br> </br>" Then
		FileWrite(@ScriptDir & "\data\tools\todo.html", "To-Do Liste </br> </br>")
	EndIf

	While 1


		$eingabetodo[$counteingabetotdo] = InputBox("Eingabe", "Gib einen Todo-Punkt ein!")
		If Not @error = 1 Then
			FileWrite(@ScriptDir & "\data\tools\todo.html", $eingabetodo[$counteingabetotdo] & "</br>")
			_IENavigate($ie, @ScriptDir & "\data\tools\todo.html")
			$counteingabetotdo = $counteingabetotdo + 1
		Else
			ExitLoop
		EndIf
	WEnd
EndFunc   ;==>todolisteeingabe



Func todolisteaufruf()
	If FileExists(@ScriptDir & "\data\tools\todo.html") Then
		_IENavigate($ie, @ScriptDir & "\data\tools\todo.html")
	Else
		MsgBox(14, "Nicht vorhanden", "Du hast noch keine To-Do Liste angelegt!")
	EndIf

EndFunc   ;==>todolisteaufruf

Func todolisteloeschen()
	$choicetodelete = MsgBox(4, "Besttigen", "Mchtest du die To-Do Liste wirklich lschen?")
	If $choicetodelete = 6 Then


		If FileExists(@ScriptDir & "\data\tools\todo.html") Then
			FileDelete(@ScriptDir & "\data\tools\todo.html")
			MsgBox(0, "Erfolgreich gelscht", "Die To-Do Liste wurde erfolgreich gelscht!")
			_IENavigate($ie, "about:blank")
		Else
			MsgBox(14, "Nicht vorhanden", "Du hast noch keine To-Do Liste angelegt!")
		EndIf
	Else

	EndIf

EndFunc   ;==>todolisteloeschen


Func speichern()
	If Not $savefile = 0 Then
		FileDelete($savefile)
		FileWrite($savefile & ".html", GUICtrlRead($main))
	Else
		$savefile = FileSaveDialog("Bitte whle das Speicherziel aus!", @ProgramFilesDir, "Website (*.html; *htm)")
		FileWrite($savefile & ".html", GUICtrlRead($main))
	EndIf

EndFunc   ;==>speichern


Func undo()
	_GUICtrlEdit_Undo($main)

EndFunc   ;==>undo